[0%]:   https://upload.wikimedia.org/wikipedia/commons/thumb/5/5c/Progress_00.svg/80px-Progress_00.svg.png "00%"
[10%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/c/c4/Progress_10.svg/80px-Progress_10.svg.png "10%"
[20%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/9/96/Progress_20.svg/80px-Progress_20.svg.png "20%"
[30%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/2/22/Progress_30.svg/80px-Progress_30.svg.png "30%"
[40%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/5/5c/Progress_40.svg/80px-Progress_40.svg.png "40%"
[50%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/f/f2/Progress_50.svg/80px-Progress_50.svg.png "50%"
[60%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/d/dd/Progress_60.svg/80px-Progress_60.svg.png "60%"
[70%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/5/5e/Progress_70.svg/80px-Progress_70.svg.png "70%"
[80%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/5/57/Progress_80.svg/80px-Progress_80.svg.png "80%"
[90%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/b/ba/Progress_90.svg/80px-Progress_90.svg.png "90%"
[100%]: https://upload.wikimedia.org/wikipedia/commons/thumb/8/82/Progress_100.svg/80px-Progress_100.svg.png "100%"
[abandonned]: http://wiki.flightgear.org/images/thumb/3/30/Cross_32px.png/16px-Cross_32px.png         "abandonné"
[done]:       http://wiki.flightgear.org/images/thumb/7/75/Tick_32px.png/16px-Tick_32px.png           "fait"
[ongoing]:    http://wiki.flightgear.org/images/thumb/3/37/Ongoing.png/16px-Ongoing.png               "en cours"
[pending]:    http://wiki.flightgear.org/images/thumb/8/8d/Hourglass_32px.png/16px-Hourglass_32px.png "en attente"
[fixed]:      http://wiki.flightgear.org/images/thumb/8/85/WIP.png/26px-WIP.png                       "réparé"
[paused]:     http://wiki.flightgear.org/images/thumb/d/dc/Paused.png/16px-Paused.png                 "en pause"

![ZKV1000, just after boot](https://sebmarque.hd.free.fr/bozon/index.php?f=158cf9534074e2)
ZKV1000 just after booting, installed in the Lancair 235 (all other instruments removed)  
[other pictures available here](https://sebmarque.hd.free.fr/bozon/index.php?f=158cf95340742d)

# Thanks
Thanks to the modeller of the [GDU104X project "Farmin/G1000"](http://wiki.flightgear.org/Project_Farmin/FG1000)(can't remember who, if he/she can tell me...) I can continue the work began many years ago with a nicer (and working) 3D model instrument. Thanks to him/her for the SVG basis file too.  
Thanks to Hooray's nice efforts, and some examples ans snipsets of code here and there from the Canvas team.  
Thanks to all FlightGear community for the funny project I let too many years off side...

# Origin
The first ZKV1000, which was completly XML animated, was completly abandonned. Moreover the Nasal code became unmaintanable from my point of view. Not sure this one is better, but I think
it is at least more modulable.

The origin is to simulate a Garmin Primus 1000, as near as possible of the [documentation found](# documentation).

But as we are in a simulation, the zkv1000 is **definitly not** a replica of the well-known G1000, as it takes the liberty to be integrated with some features that doesn't exit in
the real device, as well as some real features aren't scheduled to be implemented. But, it should be easy to add or remove features in order to get the real device. 
This is GPL-2 license though :)

# Objectives
There is no intention to provide a fully qualified G1000 in order to train or so, but this should be possible to be done from the zkv1000.

And it is intented to be a two displays device (PFD/MFD-Reversionary PFD), even if it shouldn't be that hard to make it three displays device (2 PFD, one MFD-Reversionnary PFD)

I'm particulary looking at these points:

1.  easy to implement new features
1.  optimized code (from my non-dev point of view...)
1.  easy to integrate in every cockpit with only few lines, and with easy use for the pilot
1.  near from the G1000 documentation but with some neat features added, and some unrelevant features in a sim removed

# Progress
Note: this is not because the progress bar show 100% that it means it is 100% bug free :)
Please report bug at <seb.marque@free.fr>.

* ![][100%]
  * Basic Flight Instrumentation: AI, IAS, ALT, HDG
  * Wind data widget
  * trends for altitude and speed (6s prevision)
  * TAS and Ground Speed display
  * VSI
  * 3D knobs rotate
  * map display on inflight page (with online maps downloading and caching)
  * display of NavAids on map
  * XPDR from SoftKeys and knob, with respect of delays from the manual
  * Selected altitude bug (widget off if IA within 100ft)
  * baro settings
  * SoftKeys menus navigation for PFD and MFD
    * not yet implemented function are logged in console
    * softkeys colorized when active
    * alerts with white backgroud and black text available
* ![][90%]
  * Radio stack, including ID for NAV (bug: NAV1 ID isn't displayed ![][pause])
  * Bearing needs some checks to be sure it shows the correct information
  * CDI ![][ongoing], lacks information about the scale
  * XPDR: emergency code depending of the country (eg.: 1200 for US, 7700 for Europe), should be set in settings
* ![][80%]
  * EIS: texts displayed ![][done], animations for fuel ![][ongoing]
* ![][70%]
  * make booting animation visible ![][pending]
* ![][60%]
* ![][50%]
  * EIS: animations for temperature for YaSim and JSBSim
* ![][40%]
  * use of [maketimer()](http://wiki.flightgear.org/Nasal_library#maketimer.28.29) instead of [settimer()](http://wiki.flightgear.org/Nasal_library#settimer.28.29) when possible
* ![][30%]
* ![][20%]
* ![][10%]
  * multikey for every part of the device (actually only power on)
* ![][0%] (TODO list, unsorted)
  * rotating online map on inflight page
  * some aircraft specific data to retrieve from aircraft XML files (VNE, etc)
  * display of specific speeds in ruler
  * angle of attack display
  * Alerts
  * Flight planning (MFD)
  * Setting pages (MFD)
  * Inset Map (PFD)
  * PFD settings
  * texture for some MFD buttons
  * rotation and zooming of online maps in-flight ![][pending]
  * OMI
  * VS guidance
  * VNAV
  * tutorials
  * many more...

# Installation
Somewhere in the XML configuration of your aircraft, put only few lines
## Create the `zkv1000` Nasal namespace
In the `<nasal>` place of your aircraft configuration

        <zkv1000>
            <file>Aircraft/Instruments-3d/zkv1000/zkv1000.nas</file>
        </zkv1000>

Actually this is where everything begins, please have a look at this code, it would help you to follow the script.

## 3D models
In the definition of your flightdeck (here are the values for the installation in the Lancair 235 in which I develop the device)
put it everywhere you want to

        <model>
            <path>Aircraft/Instruments-3d/zkv1000/pfd.xml</path>
            <offsets>
                <x-m> -0.023 </x-m>
                <y-m> -0.235 </y-m>
                <z-m> -0.028 </z-m>
            </offsets>
        </model>
        <model>
            <path>Aircraft/Instruments-3d/zkv1000/mfd.xml</path>
            <offsets>
                <x-m>  0.03  </x-m>
                <y-m>  0.06  </y-m>
                <z-m> -0.028 </z-m>
                <heading-deg> -15 </heading-deg>
            </offsets>
        </model>

## Switch it up
You can use the multikey (souvenirs, thanks to Melchior having that much expended this feature years ago :)) service by typing:
`:zo`

The `:z` will be the multikey entry for all multikeys of the zkv1000.

1. If you see a single red dot under the `ZKV100O xxx init` message (xxx = MFD or PFD), this is likely the sim is paused (press `p` by default to stop the pause).
1. If you see multiple dots under the `ZKV1000 xxx init` message, something wrong happened, time to check console
1. If you see only black screen on one of the screen, something really wrong happened, time to check console

# Documentation
* [Canvas in FG](http://wiki.flightgear.org/Category:Canvas)
* [Nasal](http://wiki.flightgear.org/Category:Nasal)
* the guides used to create the scenario from [Garmin website](http://support.garmin.com/support/manuals/searchManuals.faces)
    * [G1000 Pilot’s Guide for the Diamond DA42 (v0370.22)](http://static.garmin.com/pumac/190-00406-07_0B_Web.pdf) *(94 pages)*
    * [Pilot's Guide, Cirrus Perspective, SR2x (v0764.30)](http://static.garmin.com/pumac/190-00820-11_A.pdf) *(752 pages)*
